//
//      Yasuharu Okamoto, 2018.03
//
data {
    int K;
    int Nitm;
    real C[K - 1];
    real<lower = 0.0> a[Nitm];
    real b[Nitm];
    int<lower = 1, upper = K> X[Nitm];
}
parameters {
    real theta;
}
transformed parameters {
    vector[K] p[Nitm];
    for (i in 1:Nitm){
        p[i][K] = inv_logit(1.7 * a[i] * (theta - b[i] - C[K - 1]));
        p[i][1] = 1.0 - inv_logit(1.7 * a[i] * (theta - b[i] - C[1]));
        if (K > 2){
            for (k in 2:(K - 1)) {
                p[i][k] = inv_logit(1.7 * a[i] * (theta - b[i] - C[k - 1]))
                            - inv_logit(1.7 * a[i] * (theta - b[i] - C[k]));
            }
        }
    }
}
model {
    theta ~ normal(0.0, 1.0);
    for (i in 1:Nitm)
        X[i] ~ categorical(p[i]);
}
